

plotbunch=function(M,lb="3d",main="",ellipse=T,colrs=NULL,...){
  if(lb=="3d"){
#~     limSup=max(M[,1:2]);    limInf=min(M[,1:2]);    limAbs=max(limSup,abs(limInf));    ylim=c(-limAbs,limAbs);
    limSup=max(M[,3])
    limInf=min(M[,3])

    xlim=c(-limSup,limSup);    ylim=xlim;    zlim=ylim

    if(is.null(colrs)){
          if(dim(M)[2]>4){
            p1=M[,4]^2+M[,5]^2+M[,6]^2
            pt=M[,4]^2+M[,5]^2 
            #gestion color
            a=min(pt);  b=max(pt);  c=1;   d=100
            icolrs=(pt-a)/(b-a)*(d-c)+c
            colrs=rainbow(d*3)[d-icolrs+1]
          }else{
            colrs="blue"
          }
    }
    M[,1:3]=M[,1:3]
    center=mean(M)

    if(colrs[1]!=0){plot3d(M[,c(3,1,2)],xlab="",ylab="",zlab="",col=colrs,aspect=F,box=F,axes=F,...)}
    if(ellipse){ plot3d(ellipse3d(0.7*cov(M[,c(3,1,2)]),centre=center[c(3,1,2)]),alpha=0.6,col="blue",add=TRUE,box=T)}
    decorate3d(xlab="z [mm]",ylab="x [mm]",zlab="y [mm]",main=main)
    par3d(mouseMode="zAxis",cex=0.9)

    
  }else{
	  xlab=strsplit(lb,split="")[[1]][1]
	  ylab=strsplit(lb,split="")[[1]][2]
	  X=M[,switch(xlab,x=1,y=2,z=3)]
	  Y=M[,switch(ylab,x=1,y=2,z=3)]
	  dev.new();plot(X,Y,xlab=xlab,ylab=ylab,pch=".",col=4,...)
  }
}
#plotbunch(M,"xy")
#plotbunch(bunchInit)





bunchMovieFunction=function(time,tpos,nbunch,aspect,colr) {
  print(time)
  run=floor(time/SPEED*1000)
  runb=tpos[which.min(abs(tpos-run))]
#  print(c(run,runb))
  if(abs(LastRun-run)>=(1000/STEPS) && run<=1000 ){ 
      run=runb
      assign("LastRun",run,envir=.GlobalEnv)
#      print("call")
      print(run)
      M=getDistr(run=run)	
        n=dim(M)[1]
      I=seq(1,n,7)
      par3d(skipRedraw = TRUE)
#      colr=rainbow(nbunch)[run]
#      colr=rainbow(dim(M)[1])
      plot3d(M[,c(3,1,2)],xlab="",ylab="",zlab="",col=colr,aspect=aspect,box=F,axes=F)#,type="s",radius=xlim[2]/1.5)
      decorate3d(xlim=ZLIM,ylim=XLIM,zlim=YLIM,xlab="z [m]",ylab="x [m]",zlab="y [m]",aspect=aspect)
      list(skipRedraw = FALSE)
  }
}


bunchMovie=function(speed=1,out=T){
  

  
  out=F
  
  S=list.files(pattern="^[0-9]+(.X)",full.names=F,ignore.case=T)
  tpos=as.numeric(substr(S,1,3))
  nbunch=length(tpos)
  
  M=getDistr(run=tpos[nbunch]); xlim=range(M[,1]); ylim=range(M[,2]) ; zlim=range(M[,3])  
  M=getDistr(run=tpos[1]); xlim=range(c(xlim,M[,1])); ylim=range(c(ylim,M[,2])) ; zlim=range(c(zlim,M[,3]))  
  n=dim(M)[1]
  xlim=range(c(xlim,ylim))
  ylim=xlim
  
  I=seq(1,n,7)
  
  colr=rainbow(n)  
#    N=openBunch("/home/ebranlar/SpaceCharge/bunches/ellipse1110-Ek5-Ex20-1000.ini")
#  N=openBunch("/home/ebranlar/SpaceCharge/bunches/cylinder-Ek100-1000.ini")
  N=openBunch("/home/ebranlar/SpaceCharge/bunches/ellipsoid001001001-Ek100-1000.ini")
        if(dim(N)[2]>4){
            p1=N[,4]^2+N[,5]^2+N[,6]^2
            pt=N[,4]^2+N[,5]^2 
            #gestion color
            a=min(pt);  b=max(pt);  c=1;   d=100
            if(a!=b){
                  icolrs=(pt-a)/(b-a)*(d-c)+c
                  colr=rainbow(d*3)[icolrs+1]
            }else{
            colr="blue"
            }
            
          }else{
            colr="blue"
          }
    
  xlim=c(-0.4,0.05)  
  ylim=c(-0.005,0.005)
  assign("XLIM",xlim,envir=.GlobalEnv)
  assign("YLIM",ylim,envir=.GlobalEnv)
  assign("ZLIM",zlim,envir=.GlobalEnv)
    
  
  open3d()
  aspect=c(3,1,1)
  plot3d(M[,c(3,1,2)],xlab="",ylab="",zlab="",col=colr,aspect=aspect,box=F,axes=F)#,type="s",radius=xlim[2]/1.5)
  decorate3d(xlim=ZLIM,ylim=XLIM,zlim=YLIM,xlab="z [m]",ylab="x [m]",zlab="y [m]",aspect=aspect)
  
    
  speed=30
  steps=1000
  
  assign("SPEED",speed,envir=.GlobalEnv)
  assign("STEPS",steps,envir=.GlobalEnv)    
  
  assign("LastRun",0,envir=.GlobalEnv);
  if(out){  movie3d(bunchMovieFunction,SPEED,tpos=tpos,nbunch=nbunch,aspect=aspect,colr=colr,dir="./",fps=steps/speed,convert=F)
  }else{     play3d(bunchMovieFunction,SPEED,tpos=tpos,nbunch=nbunch,aspect=aspect,colr=colr)}
  
}
