axis.freq=function(fs,
	fcurrent=1/c(365*24*3600, 31*24*3600,7*24*3600, 24*3600,12*3600,3600,600,60,1),
	fnames=c("1 year","1 month","1 week","24h","12h","1h","10'","1'","1''")	){
	cexaxis=0.75
	if(PlottingMethod=="plot"){
		for(i in 1:length(fnames)){
			axis(1,at=fcurrent[i],labels=fnames[i],padj=-4.1,line=-0.5,lwd=0,lwd.ticks=1,cex.axis=cexaxis)
		}
		axis(1,at=fs/2,labels=expression(f[N]),padj=-3.25,line=-0.5,cex.axis=cexaxis)
	}else{
		for(i in 1:length(fnames)){
			axis(1,at=fcurrent[i],labels=fnames[i],padj=-2.8,line=-0.8,lwd=0,lwd.ticks=1,cex.axis=cexaxis)
		}	
		axis(1,at=fs/2,labels=expression(f[N]),padj=-2.25,line=-0.8,cex.axis=cexaxis)
	}
}








plotSpectrumR=function(R,title="Spectrum Overview",log="xy",...){
        if(length(R$f)!=length(R$S)){
		  R$f=R$f[1:length(R$S)];		
		}
		beginPlot(title,showTitle=F)
		if(log=="xy"){
			plot.loglog(R$f,R$S,type="o",col=blue,pch="",
				xaxs="i",yaxs="i",
				xlab="Frequency f [Hz]",
				ylab=expression("Energy Density F ["~m^2~s^-2~Hz^-1~"]")
                        )
        }
        if(log=="y"){
			plot.logy(R$f,R$S,type="o",col=blue,pch="",
				xaxs="i",yaxs="i",
				xlab="Frequency f [Hz]",
				ylab=expression("Energy Density F ["~m^2~s^-2~Hz^-1~"]")
                        )
        }
        if(log=="x"){
			plot.logy(R$f,R$S,type="o",col=blue,pch="",
				xaxs="i",yaxs="i",
				xlab="Frequency f [Hz]",
				ylab=expression("Energy Density F ["~m^2~s^-2~Hz^-1~"]")
                        )
        }

	axis.freq(fs);
	endPlot()
}





plotAmplitudeR=function(R,title="Amplitude Overview",...){
        beginPlot(title,showTitle=F)
	plot.loglog(R$f,R$A,type="o",col=blue,pch="",
			xaxs="i",yaxs="i",
			xlab="Frequency f [Hz]",
            ylab=expression("Amplitude A=|Y| ["~m~s^-1~"]")
                        )
	axis.freq(fs);
	endPlot()
}



plotSpectrumRB=function(R,title="Averaged Spectrum",ltyBin=0,pchBin="+",legendPos="topright",log="xy",...){
    if(length(R$f)!=length(R$S)){
		  R$f=R$f[1:length(R$S)];		
	}
	beginPlot(title,showTitle=F)
	if(log=="xy"){
		plot.loglog(R$f,R$S,type="o",col=blue,pch="",
				xaxs="i",yaxs="i",
				xlab="Frequency f [Hz]",ylab=expression("Energy Density F ["~m^2~s^-2~Hz^-1~"]"),
				main=title,...)
	}
	if(log=="y"){
		plot.logy(R$f,R$S,type="o",col=blue,pch="",
				xaxs="i",yaxs="i",
				xlab="Frequency f [Hz]",ylab=expression("Energy Density F ["~m^2~s^-2~Hz^-1~"]"),
				main=title,...)
	}
	if(log=="x"){
		plot.logx(R$f,R$S,type="o",col=blue,pch="",
				xaxs="i",yaxs="i",
				xlab="Frequency f [Hz]",ylab=expression("Energy Density F ["~m^2~s^-2~Hz^-1~"]"),
				main=title,...)
	}	
	plot.add(R$fb,R$Sb,pch=pchBin,type="o",lty=ltyBin)
	axis.freq(fs);
	mylegend(legendPos,c("Raw spectrum","Binned spectrum"),
		col=c(blue,1),pch=c("",pchBin),lty=c(1,ltyBin),bg="white",inset=0.015,cex=0.85)
	endPlot()
}



plotSpectrumRlin=function(R,title="Spectrum Overview",...){
        beginPlot(title,showTitle=F)
	plot(R$f,R$S,type="o",col=blue,pch="",
			xaxs="i",yaxs="i",
			xlab="Frequency f [Hz]",
            ylab=expression("Energy Density F ["~m^2~s^-2~Hz^-1~"]")
            ,log="y",...  )
	axis.freq(fs);
	endPlot()
}
#plotSpectrumRlin(R10yb,title="SpecMy",pchBin="",ltyBin=1,xlim=c(0.1,10),ylim=c(1,10^6))




plotSpectrumRBlin=function(R,ltyBin=0,pchBin="+",...){
    if(length(R$f)!=length(R$S)){
		  R$f=R$f[1:length(R$S)];		
	}
	#plot.empty(R$f,R$S,type="o",col=blue,pch="",
#			xaxs="i",yaxs="i",
			#xlab="Frequency f [Hz]",ylab=expression("Energy Density F ["~m^2~s^-2~Hz^-1~"]"),
			#main=title,log="y",axes=T,...)
	#grid()
	plot.logy(R$f,R$S,type="o",col=blue,pch="",xaxs="i",yaxs="i",
			xlab="Frequency f [Hz]",ylab=expression("Energy Density F ["~m^2~s^-2~Hz^-1~"]"),
			main="",...)
	plot.add(R$fb,R$Sb,pch=pchBin,type="o")
	axis.freq(fs);
}
#plotSpectrumRBlin(R10yb,pchBin="",ltyBin=1,xlim=c(0.01,10),ylim=c(1,10^6))




plotFourierCoefficientsR=function(R,title="Fourier Coefficients",...){
	beginPlot(title,showTitle=F)
	plot.loglog(R$f,Mod(R$c),col=green,type="o",pch="",
                xaxs="i",yaxs="i",
         	xlab="Frequency f [Hz]",ylab=expression("Energy Density F ["~m^2~s^-2~Hz^-1~"]"),
		main=title,...)
         plot.add(R$f,abs(R$a),col=blue,type="o",pch="")
         plot.add(R$f,abs(R$b),col=red,type="o",pch="")
	axis.freq(fs);
	legend("topright",c(expression(a_n),expression(b_n),expression(c_n)),col=c(blue,red,green),pch=c("",""),lty=c(1,1),bg="white",inset=0.015,cex=0.85)
	endPlot()
}
#plotFourierCoefficientsR(Drop.f0(R))

