library(fields) #for splint
# function colors() gives all the colors
# col=c("steelblue1","slategray1","tomato1"))
#mycol=c("chocolate1" ,"cadetblue2","steelblue2","wheat1","rosybrown","deeppink3","cornsilk1","cornsilk2","cornsilk3","mediumorchid4")
#barplot(1:20,col=mycol)

blue="#3f3f99";  #63 63 153
bluelight="#d8d8ea";  #216 216 234
red="#993d71";   #153 61 113
redlight="#ead8e2"; #234 216 226
green="#3d9956"; #61 153 86
#greenlight="#d8eadd";  #216 234 221
yellow="#988b3d" #152 140 61
yellowlight="#eae8d8"; # 234 232 216


rainbow=function (n, s = 1, v = 1, start = 0, end = 0.7, 
    gamma = 1, alpha = 1) 
{
    if ((n <- as.integer(n[1])) > 0) {
        if (start == end || any(c(start, end) < 0) || any(c(start, 
            end) > 1)) 
            stop("'start' and 'end' must be distinct and in [0, 1].")
        hsv(h = seq.int(start, ifelse(start > end, 1, 0) + end, 
            length.out = n)%%1, s, v, gamma, alpha)
    }
    else character(0)
}


#  f1 <- kde2d(geyser$duration, geyser$waiting, n = 50,  lims = c(0.5, 6, 40, 100))
#  f1 <- kde2d(X,Y, n = 50)
#  filled.contour(f1, col = rev(grey.colors(50)), nlevels = 50) 

rev.grey.colors=function (n, start = 0, end = 1, gamma = 1.5) {
  rev(gray(seq.int(from = start^gamma, to = end^gamma, length.out = n)^(1/gamma)))
}
green.colors=function(n, start = 0, end = 1, gamma = 1.1) {
  return(rev(hsv(0.35,1-seq.int(from = start^gamma, to = end^gamma, length.out = n)^(1/gamma),1)))
}
tim2white.colors=function(n=59) {
  orig <- c( 
        "#0080FF", "#008FFF", "#009FFF", "#00AFFF", "#00BFFF", 
        "#00CFFF", "#00DFFF", "#00EFFF", "#00FFFF", "#10FFEF", 
        "#20FFDF", "#30FFCF", "#40FFBF", "#50FFAF", "#60FF9F", 
        "#70FF8F", "#80FF80", "#8FFF70", "#9FFF60", "#AFFF50", 
        "#BFFF40", "#CFFF30", "#DFFF20", "#EFFF10", "#FFFF00", 
        "#FFEF00", "#FFDF00", "#FFCF00", "#FFBF00", "#FFAF00", 
        "#FF9F00", "#FF8F00", "#FF8000", "#FF7000", "#FF6000", 
        "#FF5000", "#FF4000", "#FF3000", "#FF2000", "#FF1000", 
        "#FF0000", "#EF0000", "#DF0000", "#CF0000", "#BF0000", 
        "#AF0000", "#9F0000", "#8F0000", "#800000")
    orig=c(rev(hsv(0.6,1-seq.int(from = 0.6, to = 1, length.out = 10),1)),orig)
    if (n == 59) 
        return(orig)
    rgb.tim <- t(col2rgb(orig))
    temp <- matrix(NA, ncol = 3, nrow = n)
    x <- seq(0, 1, ,59)
    xg <- seq(0, 1, , n)
    for (k in 1:3) {
        hold <- splint(x, rgb.tim[, k], xg)
        hold[hold < 0] <- 0
        hold[hold > 255] <- 255
        temp[, k] <- round(hold)
    }
    rgb(temp[, 1], temp[, 2], temp[, 3], maxColorValue = 255)

}
#plot(1:100,col=tim2white.colors(100))
#plot.all.ellipses(runs=c(1),points=c(4),axe="z",dolegend=F,realDensity=T,colDensity="tim2white")

red.colors=function(n, start = 0.01, end = 1, gamma = 1.1) {
  return(rev(hsv(1,1-seq.int(from = start^gamma, to = end^gamma, length.out = n)^(1/gamma),1)))
}
blue.colors=function(n, start = 0, end = 1, gamma = 1.1) {
  return(rev(hsv(0.6,1-seq.int(from = start^gamma, to = end^gamma, length.out = n)^(1/gamma),1)))
}


#myfilled.contour(f1, color.palette=red.colors)


















##################################################################################
# A list of popular names for colors from packages
# RColorBrewer, colorRamps, grDevices
##################################################################################
library(RColorBrewer)
library(colorRamps)
showColors=function (){
#
# make sure that output device is large enough
#
# png("colorNames.png",width=1600,height=1000)
layout(rbind(c(1,2), c(3,2)),widths=c(2,3.5),heights=c(2,1))

par(mar=c(0,5,1,0), cex.lab=1.4, cex.axis=1.4, cex.main=1.4, cex.sub=1.4)
display.brewer.all()
mtext("Color names for colors from the RColorBrewer package",3,line=-1,cex=2)


par(mar=c(0,0,0,0), cex.lab=1.4, cex.axis=1.4, cex.main=1.4, cex.sub=1.4)
colorNames = colors()
plot.new()
for (j in 1:60) {
	for (i in 1:11) {
	  kolor = colorNames[(i-1)*60+j]
		rect(i/11,j/60,(i-1)/11,(j-1)/60,col=kolor)
		text((i-0.5)/11,(j-0.5)/60,kolor,col=ifelse(mean(col2rgb(kolor))<120,"white","black"))
	}
}
mtext("Color names for colors(grDevices)",3,line=-2,cex=2)


par(mar=c(3,0,3,0), cex.lab=1.4, cex.axis=1.4, cex.main=1.4, cex.sub=1.4)
plot.new()
mtext("Color names for grDevices and colorRamps packages",3,cex=2)

#
# this could be done in a more elegant way
#
colorLists = list(rainbow, heat.colors, terrain.colors, topo.colors, cm.colors, blue2red, blue2green, green2red, blue2yellow, cyan2yellow, magenta2green)

colorsSampels = NULL
for (i in seq_along(colorLists)) {
 colorsSampels[[i]] = colorLists[[i]](100)
}

for (i in 2:100) {
   for (j in seq_along(colorLists)) {
      rect(i/100,j/11 - 0.01,(i-1)/100,(j-1)/11,col=(colorsSampels[[j]])[i], border=NA)
   }
}
text(0.5,((1:11)-0.5)/11,c("rainbow(grDevices)", "heat.colors(grDevices)", "terrain.colors(grDevices)", "topo.colors(grDevices)", "cm.colors(grDevices)", "blue2red(colorRamps)", "blue2green(colorRamps)", "green2red(colorRamps)", "blue2yellow(colorRamps)", "cyan2yellow(colorRamps)", "magenta2green(colorRamps)"),cex=1.4, adj=c(0.5,0.5))

# dev.off()
}
