
densityplot=function(...){
  plot(density.default(...))
}


argcth=function(x){

  return( 0.5*(log(1+1/x)-log(1-1/x)) )
}

argch=function(x){

  return( log(x+sqrt(x+1)*sqrt(x-1) ) )
}

arccotg=function(x){
   return(Re( complex(1,0,1)/2* (log( (x-complex(1,0,1))/x ) - log( (x+complex(1,0,1))/x )) ))
}
#########################################################
# Integration
#########################################################
#library(Bolsatd) ?sintegral  or: library(caTools) ?trapz
trapz=function(x,y){
  return(sum(diff(x)*(y[-1]+y[-length(y)]))/2)
}



inverse=function(A){

 InvA=matrix(NA,3,3)

      det=(A[2,2]*A[3,3]-A[2,3]*A[3,2])*A[1,1]+(A[2,3]*A[3,1]-A[2,1]*A[3,3])*A[1,2]+(A[2,1]*A[3,2]-A[2,2]*A[3,1])*A[1,3]
      InvA[1,1]=(A[2,2]*A[3,3]-A[2,3]*A[3,2])/det
      InvA[2,1]=(A[2,3]*A[3,1]-A[2,1]*A[3,3])/det
      InvA[3,1]=(A[2,1]*A[3,2]-A[2,2]*A[3,1])/det
      InvA[1,2]=(A[3,2]*A[1,3]-A[3,3]*A[1,2])/det
      InvA[2,2]=(A[3,3]*A[1,1]-A[3,1]*A[1,3])/det
      InvA[3,2]=(A[3,1]*A[1,2]-A[3,2]*A[1,1])/det
      InvA[1,3]=(A[1,2]*A[2,3]-A[1,3]*A[2,2])/det
      InvA[2,3]=(A[1,3]*A[2,1]-A[1,1]*A[2,3])/det
      InvA[3,3]=(A[1,1]*A[2,2]-A[1,2]*A[2,1])/det
         
    return(InvA)
}


fstep=function(x){
    return(as.numeric(x>=0));
}

fsigne=function(x){
    return(-as.numeric(x<0)+as.numeric(x>0));
}

fderRight=function(x,Dt){
    n=length(x);
    y=numeric();
    for(i in 1:(n-1)){
      y[i]=(x[i+1]-x[i])/Dt;
   }
   y[n]=y[n-1]; #extension by continuity, assumption made to return of full vector
   return(y)
}

fderLeft=function(x,Dt){
    y=numeric();
    n=length(x);
    for(i in 2:n){
      y[i]=(x[i]-x[i-1])/Dt;
   }
   y[1]=y[2]; #extension by continuity, assumption made to return of full vector
   return(y)
}

fderCentered=function(x,Dt){
   n=length(x);
   y=numeric();
   for(i in 2:(n-1)){
      y[i]=(x[i+1]-x[i-1])/(2*Dt);
   }
   y[1]=y[2]; #extension by continuity, assumption made to return of full vector
   y[n]=y[n-1]; #extension by continuity, assumption made to return of full vector
   return(y)
}

fdelta=function(x){
   return(as.numeric(abs(x)<0.05));
}

