require("chron")

mygrid=function(nx = NULL, ny = nx, col = "grey30", lty = "dotted",lwd=2,...){
	grid(nx,ny,col="grey30",lty="dotted",lwd=lwd,...)
}


#library("sfsmisc") #to have errorbar

#plot(d, type = "n")
#polygon(d, col = "wheat")

#legend("topright", c("ta mere","enshort"),pch=c(1,2), title="flagada",inset = .02,lty=1,ncol=2,col="black",lwd=1,cex=1,pt.cex=3)
# xaxs = "i", yaxs = "i"  to avoid the 4% offset inside the plot

#################################################################################
#################################################################################
#################################################################################
# elementary functions
#################################################################################
#################################################################################
#################################################################################


setPlottingMethod=function(Method=c("plot","png","pdf")){
  assign("PlottingMethod",Method, envir = .GlobalEnv)
}

setFigsPath=function(Path=c("./")){
  assign("FigsPath",Path, envir = .GlobalEnv)
}

beginPlot=function(main="",PPT=F,showTitle=T,width=12,height=9,big=F,...){
  if(!exists("PlottingMethod")){setPlottingMethod("plot")}
  if(!exists("FigsPath")){setFigsPath("./")}  

  if(PlottingMethod=="png"){
     mypng(file=paste(FigsPath,title2filename(main),".png",sep=""),PPT=PPT,showTitle=showTitle,width=width,height=height)
  }
  if(PlottingMethod=="pdf"){
	 if(big){
		mypng(file=paste(FigsPath,title2filename(main),".png",sep=""),PPT=PPT,showTitle=showTitle,width=width,height=height)	 
	 }
	 else{
		mypdf(file=paste(FigsPath,title2filename(main),".pdf",sep=""),PPT=PPT,showTitle=showTitle,width=width,height=height)
	}
  }
  if(PlottingMethod=="plot"){
     dev.new()
  }
}

endPlot=function(bBox=T){
	if(bBox){  box(lwd=2)  }
  if(PlottingMethod=="png" || PlottingMethod=="pdf"){
     dev.off();
  }
}


#mypng=function(...,width = 12, height=9,PPT=F,showTitle=T){
#   if(PPT){ width = 25; height=19; showTitle=T;}
#   png(width = width, height=height, units = "cm",res=300,pointsize = 10, bg = "white",...)
#   if(PPT){
##     par(mar=c(4.5, 4.5, 4.2, 2));
#     par(mar=c(2.5, 2.5, 2.2, 1));
##     par(mgp=c(2, 2, 0))
#     par(ps=40)
#   }else{
#     par(mar=c(2.5, 2.5, 0, 1));
#     par(mgp=c(1.4, 0.6, 0))
#     if(!showTitle){
#            par(mar=c(2.5,2.5,0.5,1), col.main="white",cex.main=0.1)
#     }else{
#            par(mar=c(2.5, 2.5, 2.2, 2));
#      }
#     par(ps=10)
#   }
#}




mypng=function(...,width = 12, height=9,PPT=F,showTitle=T){
   if(PPT){ width = 25; height=19; showTitle=T;}
   png(width = width, height=height, units = "in",res=300,pointsize = 12, bg = "white",...)
   if(PPT){
     par(mar=c(2.5, 2.5, 2.2, 1));
     par(ps=40)
   }else{
     par(mar=c(2.5, 2.5, 0, 1));
     par(mgp=c(4, 1.8, 0))
     if(!showTitle){
            par(mar=c(5.7,6.4,2.1,3), col.main="white",cex.main=0.1)        
     }else{
            par(mar=c(5.7, 6.4, 4, 3));
            par(cex.main=0.9)
      }
     par(cex.axis=0.9)
     par(tcl=-0.8)
     par(ps=26)
   }
}

mypdf=function(...,width = 12, height=9,PPT=F,showTitle=T){
   if(PPT){ width = 25; height=19; showTitle=T;}
	#here the length are in inches...
   pdf(width = width, height=height, pointsize = 12,family="sans",...)
   if(PPT){
     par(mar=c(2.5, 2.5, 2.2, 1));
     par(ps=40)
   }else{
     par(mar=c(2.5, 2.5, 0, 1));
     par(mgp=c(4, 1.8, 0))
     if(!showTitle){
            par(mar=c(5.7,6.4,2.1,3), col.main="white",cex.main=0.1)        
     }else{
            par(mar=c(5.7, 6.4, 4, 3));
            par(cex.main=0.9)
      }
     par(cex.axis=0.9)
     par(tcl=-0.8)
     par(ps=26)
   }
}
#~ beginPlot("a",showTitle=F);plot.loglog(f,Smean,type="o",ylab="Y [m/s]",xlab="U [m]",col=4,pch="",main="Tartempiion turlutte");endPlot();
#~ axis(1,at=fcurrent,labels=fnames,padj=0,line=2.2)

compressPDF <- function(x) {
  system(paste("pdftk",x,"output",sub("\\.pdf","c.pdf",x),
               "compress dont_ask"))
  unlink(x)
}



title2filename=function(title){
  filename=unlist(strsplit(title,"\n"));
  filename=paste(filename,collapse="_");
  filename=unlist(strsplit(filename," "));
  filename=paste(filename,collapse="_");
  filename=unlist(strsplit(filename,"m/s"));
  filename=paste(filename,collapse="mps");
  filename=unlist(strsplit(filename,"/"));
  filename=paste(filename,collapse="over");
  filename=unlist(strsplit(filename,"|"));
  filename=paste(filename,collapse="");
  filename=unlist(strsplit(filename,":"));
  filename=paste(filename,collapse="");
  filename=unlist(strsplit(filename,"[.]"));
  filename=paste(filename,collapse="");
  filename=unlist(strsplit(filename,"[,]"));
  filename=paste(filename,collapse="");
  print(paste("\\image{",filename,"}{",title,"}{0.55}",sep=""))
  return(filename)
}



clearFig=function(){
  try(rgl.quit(),silent=T)
  for(i in 1:10){try(dev.off(),silent=T);}
  try(library(rgl),silent=T)
} 

close.all=function(){
  try(rgl.quit(),silent=T)
  for(i in 1:10){try(dev.off(),silent=T);}
  try(library(rgl),silent=T)
} 



errorBar = function (x, y, std, cap = 0.015,...)
{
    xcoord <- par()$usr[1:2]
    #if(length(std(is.na(std)))==0){
      yminus=y-std;
      yplus=y+std;
      segments(x, yminus, x, yplus,col="black")
      smidge <- cap * (xcoord[2] - xcoord[1])/2
      segments(x - smidge, yminus, x + smidge, yminus,col="black")
      segments(x - smidge, yplus, x + smidge, yplus,col="black")

}

simplePlot=function(col="blue",...){
    plot(pch="",type = "o",col=col,cex=1,frame.plot=TRUE,lwd=2,...)
}

simplePlot2=function(...){
    plot(pch="",type = "o",col="blue",cex=1,frame.plot=TRUE,lwd=2,...)
}

plot.logx=function(X,Y,majorgrid=T,minorgrid=T,ygrid=Y,ylim=range(Y),...){
	pretX=pretty(X)
	pretY=pretty(c(Y,ylim))
	rX=range(X,na.rm=T)
	rY=range(Y,na.rm=T)
	xmgrid=seq.log(rX)
	v=log(rX)/log(10)
	xMgrid=10^(v[1]:v[2])

	plot.empty(rX,rY,log="x",ylim=ylim,...)
	abline(v=xmgrid,col="lightgray")
	abline(v=xMgrid,col="gray")
	abline(h=pretY,col="gray")
	par(new=T)
	plot(X,Y,log="x",axes=F,frame.plot=T,ylim=ylim,...)
	axis(2,at=pretY)
	axis(1,at=xMgrid)
}
#plot.logx(Vn,stds,col=4,pch="+")




plot.logy=function(X,Y=NULL,majorgrid=T,minorgrid=T,ygrid=Y,xlim=range(X),ylim=range(Y),...){
	if(is.null(Y) && is.list(X)){
		Y=X$S;
		ylim=range(Y)
		X=X$f;
	}
	if(X[1]==0){
		X=X[2:length(X)];
		Y=Y[2:length(Y)];
	}
	
	### Work on axis, ticks and labels
	rX=range(xlim,na.rm=T)
	rY=range(ylim,na.rm=T)
	#minor grid
	ymgrid=seq.log(rY)	
	#Major grid
	xMgrid=pretty(rX)
	py=powerrange(rY)
	Vpy=py[1]:py[2];
	yMgrid=10^(Vpy)

	xmgrid=pretty(rX,n=2*length(xMgrid))
	ylim=range(yMgrid);


	### Plotting
	plot.empty(rX,rY,log="y",xlim=xlim,ylim=ylim,axes=F,frame.plot=T,...)
	# grid
	if(minorgrid){
		abline(v=xmgrid,col="lightgray")
		abline(h=ymgrid,col="lightgray")
	}
	if(majorgrid){
		abline(v=xMgrid,col="gray")
		abline(h=yMgrid,col="gray")
	}
	# plot
	par(new=T)
	plot(X,Y,log="y",xlim=xlim,ylim=ylim,axes=F,...)
	#labels
     for(py in pretty(Vpy)){
			if(10^py>=ylim[1] && 10^py<= ylim[2] && floor(py)==py)
				axis(2,at=10^py,bquote(10^.(py)))
	}
	axis(1)
}
#plot.logx(Vn,stds,col=4,pch="+")
#plot.logy(R10$f,R10$S,xlim=c(0.01,18),pch="",type="o",col=blue)





plot.loglog=function(X,Y=NULL,majorgrid=T,minorgrid=T,ygrid=Y,xlim=range(X),ylim=range(Y),...){
	if(is.null(Y) && is.list(X)){
		Y=X$S;
		ylim=range(Y)
		X=X$f;
	}
	if(X[1]==0){
		X=X[2:length(X)];
		Y=Y[2:length(Y)];
	}
	
	### Work on axis, ticks and labels
	rX=range(xlim,na.rm=T)
	rY=range(ylim,na.rm=T)
	#minor grid
	xmgrid=seq.log(rX)
	ymgrid=seq.log(rY)	
	#Major grid
	px=powerrange(rX)
	Vpx=px[1]:px[2];
	xMgrid=10^(Vpx)
	py=powerrange(rY)
	Vpy=py[1]:py[2];
	yMgrid=10^(Vpy)

	xlim=range(xMgrid);
	ylim=range(yMgrid);

	### Plotting
	plot.empty(rX,rY,log="xy",xlim=xlim,ylim=ylim,axes=F,frame.plot=T,...)
	# grid
	if(minorgrid){
		abline(v=xmgrid,col="lightgray")
		abline(h=ymgrid,col="lightgray")
	}
	if(majorgrid){
		abline(v=xMgrid,col="gray")
		abline(h=yMgrid,col="gray")
	}
	# plot
	par(new=T)
	plot(X,Y,log="xy",xlim=xlim,ylim=ylim,axes=F,...)
	#labels
	#par(las=1) #horizontal
	for(px in pretty(Vpx)){
			if(10^px>=xlim[1] && 10^px<= xlim[2] && floor(px)==px)
				axis(1,at=10^px,bquote(10^.(px)))
	}
     for(py in pretty(Vpy)){
			if(10^py>=ylim[1] && 10^py<= ylim[2] && floor(py)==py)
				axis(2,at=10^py,bquote(10^.(py)))
	}


}
#beginPlot("a");plot.loglog(f,S,type="o",col=4,pch="",xaxs="i",yaxs="i");endPlot();


lines.circle=function(xc,yc,r,...){
	theta=seq(0,2*pi,length.out=30)
	lines(xc+r*cos(theta),yc+r*sin(theta),...)
}


plot.add=function(x,y,...){
	points(x,y,...)
}

plot.empty=function(X,Y,type="n",xlab="",ylab="",axes=F,ylim=range(Y,na.rm=T),...){
	plot(range(X,na.rm=T),range(Y,na.rm=T),type="n",xlab=xlab,ylab=ylab,axes=axes,ylim=ylim,...)
}



plotWithGrid=function(x,y,xmin,xmax,ymin,ymax,Xgrid,Ygrid,std=NULL,ErrorBar=FALSE,BarPlot=FALSE,type="o",pch="+",col="blue",xlab="",ylab="",...){
    #plot(0,xlim=c(xmin,xmax),ylim=c(ymin,ymax),type=type,pch="",axes=FALSE,main="",xlab="",ylab="")
    plot.empty(x,y,xlim=c(xmin,xmax),ylim=c(ymin,ymax),frame.plot=TRUE,xlab=xlab,ylab=ylab,...)
    axis(1,pretty(seq(xmin,xmax,(xmax-xmin)/Xgrid),Xgrid))
    axis(2,pretty(seq(ymin,ymax,(ymax-ymin)/Ygrid),Ygrid))
    abline(v=pretty(seq(xmin,xmax,(xmax-xmin)/Xgrid),Xgrid),h=pretty(seq(ymin,ymax,(ymax-ymin)/Ygrid),Ygrid),col = "lightgray", lty=3)
    par(new=TRUE)
    if(BarPlot){
      barplot(y,width=(xmax-xmin)/length(x),space=0,ylim=c(ymin,ymax), axes=FALSE,xaxs="i",yaxs="i",col=col,...)
    }else{
      plot(x,y,xlim=c(xmin,xmax),ylim=c(ymin,ymax),type=type,pch=pch,col=col,axes=FALSE,frame.plot=TRUE,...)
    }

    if(ErrorBar){
      errorBar(x,y,std,...)
#      xlim=c(min,max),ylim=c(ymin,ymax),...)
    }
}
#plotWithGrid(x,y,0,30,0,15000,ErrorBar=F,BarPlot=T,col=4,Xgrid=5,Ygrid=5)


timePlotWithGrid=function(t,y,xaxs="r",yaxs="r",...){
	#this function assumes that t inherits of time t=times((1:60)/3600/24)
    plot.empty(t,y,xaxs=xaxs,yaxs=xaxs)
    abline(v=getTimeTicksPosition(t),h=axTicks(2),col = "lightgray", lty=3)
    par(new=T)
    plot(t,y,xaxs=xaxs,yaxs=xaxs,...)

}




#################################################################################
#################################################################################
#################################################################################
# Complex functions
#################################################################################
#################################################################################
#################################################################################

plotSurf=function(M,x=NULL,y=NULL,pos=c(1,400,400,800),xlab="",ylab="",zlab="",main="",...){
       userMat=t(matrix(c(0.6950792, -0.7189313, -2.347044e-08 , 0, 0.2458890 , 0.2377311,  9.396913e-01,   0, -0.6755744, -0.6531608  ,3.420197e-01,    0, 0.0000000,  0.0000000  ,0.000000,    1),4,4))
      z <- as.matrix(M)
      if(is.null(x)){ x <- (1:nrow(z)) }
      if(is.null(y)){ y <- (1:ncol(z)) }
      #gestion color
      a=min(z);  b=max(z);  c=1;   d=100
      icolrs=(z-a)/(b-a)*(d-c)+c
      colrs=tim.colors(d)[icolrs]

      open3d(); 
      par3d(userMatrix=userMat,mouseMode="zAxis",cex=0.9,windowRect=pos);
      surface3d(x, y, z, color=colrs, back="lines",aspect=T,...)
      decorate3d(aspect=T,xlab=xlab,ylab=ylab,zlab=zlab,main=main,...)
#      A=list();   A$x=x;  A$y=y; A$z=z;
#      plot.surface(A, type="C",...) # surface plot
      x11(xpos=(pos[1]+1500),ypos=pos[2]-300,width=(pos[3]-pos[1])/100,height=(pos[4]-pos[2])/100)     
      grid <- expand.grid(x=x, y=y)
      grid$z=as.vector(z)
      levelplot(z~x*y,grid, col.regions=tim.colors(),cut=64, xlab=xlab,ylab=ylab,main=main,
        panel = function(..., axes=F,at, contour = F, labels = NULL,region=T) {
              panel.levelplot(...,cut=64, at = at, contour = contour, labels = labels)
              panel.contourplot(..., at = pretty(z), contour = T,labels = T,region=F)
          })
}
#plotSurf(M=monrho$z,x=monrho$x,y=monrho$y,main="RHO",pos=c(901,zf1,1300,zf2))

filled.contour.add=function(){
   mar.orig <- (par.orig <- par(c("mar", "las", "mfrow")))$mar
   w <- (3 + mar.orig[2]) * par("csi") * 2.54
   layout(matrix(c(2, 1), ncol = 2), widths = c(1, lcm(w)))
   par(new=T)
}
# filled.contour(z,x,B,nlevels=100)
# filled.contour.add()
# par(new=T);plot(2:10)


filled.contour.nolegend=function (x = seq(0, 1, length.out = nrow(z)), y = seq(0, 1, 
    length.out = ncol(z)), z, xlim = range(x, finite = TRUE), 
    ylim = range(y, finite = TRUE), zlim = range(z, finite = TRUE), 
    levels = pretty(zlim, nlevels), nlevels = 20, color.palette = cm.colors, 
    col = color.palette(length(levels) - 1), plot.title, plot.axes, 
    key.title, key.axes, asp = NA, xaxs = "i", yaxs = "i", las = 1, 
    axes = TRUE, frame.plot = axes, ...) 
{
    if (missing(z)) {
        if (!missing(x)) {
            if (is.list(x)) {
                z <- x$z
                y <- x$y
                x <- x$x
            }
            else {
                z <- x
                x <- seq.int(0, 1, length.out = nrow(z))
            }
        }
        else stop("no 'z' matrix specified")
    }
    else if (is.list(x)) {
        y <- x$y
        x <- x$x
    }
    mar.orig <- (par.orig <- par(c("mar", "las", "mfrow")))$mar
    on.exit(par(par.orig))
    par(mar = mar.orig)
    plot.new()
    plot.window(xlim, ylim, "", xaxs = xaxs, yaxs = yaxs, asp = asp)
    if (!is.matrix(z) || nrow(z) <= 1 || ncol(z) <= 1) 
        stop("no proper 'z' matrix specified")
    if (!is.double(z)) 
        storage.mode(z) <- "double"
    .Internal(filledcontour(as.double(x), as.double(y), z, as.double(levels), 
        col = col))
    if (missing(plot.axes)) {
        if (axes) {
            title(main = "", xlab = "", ylab = "")
            Axis(x, side = 1)
            Axis(y, side = 2)
        }
    }
    else plot.axes
    if (frame.plot) 
        box()
    if (missing(plot.title)) 
        title(...)
    else plot.title
    invisible()
}


# the following function is an adaptation of the function chron:::axis.times
# it returns the times corresponding to the ticks that are plotted by chron
# that's the only solution I found to plot the grid at the good position
getTimeTicksPosition=function(x)   {
   if (!inherits(x, "times"))
        x <- chron(x)
    bad <- is.na(x) | abs(as.vector(x)) == Inf
    rng <- par("usr")[1:2]
    tmp <- c(rng, as.numeric(x[!bad]))
    rng1 <- diff(range(tmp))
    if (rng1 > 1)
        fctr <- 1
    else if (rng1 > 1/24)
        fctr <- 24
    else if (rng1 > 1/1440)
        fctr <- 1440
    else fctr <- 86400
    tmp <- pretty(fctr * tmp)/fctr
    if (TRUE) {
        step <- diff(tmp[1:2])
        simplify <- step >= 1/1440
        if (inherits(x, "chron") && step >= 1)
            class(x) <- class(x)[-1]
    }
    att <- attributes(x)
    at.x <- structure(tmp[tmp >= rng[1] & tmp <= rng[2]], format = att$format,
        origin = att$origin, class = att$class)
    return(at.x)
}









multiPlot=function(X,Y=NULL,xlim=NULL,ylim=NULL,xlab="",ylab="",main="",pch=NULL,Vlty=NULL,Vcol=NULL,legendNames=NULL,legendPos=NULL,legendTitle=NULL,ncol=1,formatEngX=F,formatEngY=T,...){
  #if Y=null then we change X and Y, X will be the indices
  if(is.null(Y)){
    Y=X;
    X=1:max(dim(Y))
  }
  #we transpose the data if the sets are not in columns
  l=length(X);
  if(dim(Y)[2]==l){Y=t(Y)}
  n=dim(Y)[2];
  #defining limits from X and the first columns of Y
  if(is.null(xlim)){xlim=c(min(X,na.rm=TRUE),max(X,na.rm=TRUE))}
  if(is.null(ylim)){ylim=c(min(Y,na.rm=TRUE),max(Y,na.rm=TRUE))}
  #ylim=c(0.00001,1000)

  if(is.null(pch)){
    Vpch=c(0,1,2,5)
  }else{Vpch=pch}
  if(is.null(Vcol)){
      Vcol=c(1,4,2,3)
  }
  if(is.null(Vlty)){Vlty=c(rep(1,length(Vpch)),rep(5,length(Vpch)),rep(3,length(Vpch)),rep(4,length(Vpch)))}
  plot(0,0,xlim=xlim,ylim=ylim,pch="",type="n",axes=TRUE,xlab=xlab,ylab=ylab,main=main,yaxt="n",xaxt="n")
  
  if(formatEngY){axis(2,labels=formatEng(pretty(ylim,5)),at=pretty(ylim,5))}else{axis(2,labels=pretty(ylim,5),at=pretty(ylim,5))}
  if(formatEngX){axis(1,labels=formatEng(pretty(xlim,5)),at=pretty(xlim,5))}else{axis(1,labels=pretty(xlim,5),at=pretty(xlim,5))}
  grid()
  
  for(i in 1:n){
    par(new=TRUE)
    plot(X,Y[,i],xlim=xlim,ylim=ylim,xlab="",ylab="",main="",axes=FALSE,pch=Vpch[(i-1)%%length(Vpch)+1],lty=Vlty[(i-1)%%(length(Vlty))+1],type="o",col=Vcol[(i-1)%%(length(Vcol))+1],cex=0.8,...)
  }
  
  if(is.null(legendNames)){
    legendNames=1:length(Y[1,])
  }
  if(is.null(legendPos)){
    legendPos="topright";
  }
  legend(legendPos,legend=legendNames,pch=Vpch,inset = .02,lty=Vlty,col=Vcol,ncol=ncol,lwd=1,cex=0.8,bg="white",title=legendTitle)
}
#plotWSBinFFT(U=c(10,20,30))
#multiPlot(AValues,PDF_A_bind[[k]],main=paste("tau:",Tau[k]),legendNames=SigValues,xlab="A",ylab="PDF")
#multiPlot(Values,PDF_A_sig_bind,main="gfhgfh",legendNames=Tau,xlab="A/sig",ylab="PDF",xlim=c(-5,5))
# multiPlot(1:4/10,rbind(MEmaxAstra[,1:4],MEmaxTheory[,1:4]),legendNames=c("1","2","3","4","1 (th)","2 (th)","3 (th)","4 (th)"),legendTitle="RMS Radius [mm] : ",xlab="Z rms [mm]",ylab="Ez max [V/m]",main="Ez max, 0.25 nC, 15MeV")  





