################################################################################################
#MoveAve will average the values of x to avoid very high fluctuations in the measured signal
#If fernsterbreite is F, then out[i]=average of x[i-F/2], x[i-F/2+1], ..., x[i], ..., x[i+F/2]
#The first and last values of out can't be calculated, that's why we replce them by NA
################################################################################################

#windowSize<-> number of data on witch the average will be done
MoveAve<-function(x, windowSize)
{
	return(filter(x, rep(1/windowSize, windowSize), side=2)  )
}


################################################################################################
#MoveAveAngel will average the values of x
#Negativ angles returned by atan2 will be returned positive by adding 360
################################################################################################
MoveAveAngle<-function(x, Fensterbreite)
{
 a    = MoveAve(sin(x/180*pi), Fensterbreite)
 b    = MoveAve(cos(x/180*pi), Fensterbreite)
 c    = atan2(a,b)/pi*180
 l    = which(c<0)
 c[l] = c[l]+360
 invisible(c)
}

