
yearlyMax=function(WS,Years,ystart){
	ym=numeric(length(Years))
	for(j in 1:(length(ystart)-1)){
		ym[j]=max(WS[ystart[j]:(ystart[j+1]-1)],na.rm=T)
	}
	return(ym)
}
#ym=yearlyMax(MM[,1],Years,ystart)

plotYearlyMax=function(Years,AnnualMax,plotFlag="",showTitle=F){
	ymax=pretty(max(AnnualMax,na.rm=T))[2];
	beginPlot(paste(plotFlag,"YearlyMax",sep=""),showTitle=showTitle)
		barplot(AnnualMax,space=0.1, names.arg= Years, ylim=c(0,ymax),
		offset=0, axes=T,xaxs="i",yaxs="i",
		col="slategray1",xlab="Years",ylab="Maximum wind speed [m/s]")
#~ 		col=bluelight,xlab="Years",ylab="Maximum wind speed [m/s]")
		axis(1,at=Years,labels=NULL)
	endPlot()
}
#plotYearlyMax(Years,ym)






getGumbel50yExtreme=function(AnnualMax,Avail,plotFlag=""){
	# Cumulative distribution
	AnnualMax=AnnualMax[which(Avail>0.9)];
	N=length(AnnualMax);
	U=sort(AnnualMax)
	P=1:N/(N+1)

	#probability for 50 years
	p50=0.98;


	###########################################################
	# Gumbel
	###########################################################
	# first regression
	R=lm(-log(-log(P)) ~ U )
	b=R$coefficients[1];
	a=R$coefficients[2];
	U50=(-log(-log(p50))-b)/a
	U2=seq(10,U50,length.out=100)

	xmin=pretty(min(AnnualMax))[1]
	xmax=pretty(U50)[2]
	
	#regression coefficient
	Reg2=1-(sum((-log(-log(P))-(a*U+b))^2))/(sum((-log(-log(P))+mean(-log(-log(P)))  )^2))




	beginPlot(paste(plotFlag,"GumbelLogLog",sep=""))
		plot.empty(U,-log(-log(P)),axes=T,ylab="Cumulative probability [.] - log-log",xlab="Maximum wind speed [m/s]",xlim=c(xmin,xmax),ylim=c(-1.5,4))
		grid()	
		plot.add(U,-log(-log(P)),col=blue,pch=19)
		abline(h=-log(-log(p50)),col=1)
		plot.add(U2,a*U2+b,col=1,type="o",pch="",lty=2)
		plot.add(U50,-log(-log(p50)),col=red,pch=19)	
		axis(1,at=floor(U50*10)/10,padj=-2.8,line=-0.8)
		legend("right",c("Available data","Extrapolation","Gumbel distribution"),col=c(blue,red,1,1),pch=c(19,19,NA),lty=c(0,0,2,4),bg="white",inset=0.015,cex=0.85)
	endPlot()


	beginPlot(paste(plotFlag,"GumbelLin",sep=""))
		plot.empty(U,P,axes=T,ylab="Cumulative probability [.]",xlab="Maximum wind speed [m/s]",xlim=c(xmin,xmax),ylim=c(0,1))
		grid()	
		plot.add(U,P,col=blue,pch=19)
		abline(h=p50,col=1)
		plot.add(U2,exp(-exp(-(a*U2+b))),col=1,type="o",pch="",lty=2)
		plot.add(U50,p50,col=red,pch=19)	
		axis(1,at=floor(U50*10)/10,padj=-2.8,line=-0.8)
		legend("right",c("Available data","Extrapolation","Gumbel distribution"),col=c(blue,red,1,1),pch=c(19,19,NA),lty=c(0,0,2,4),bg="white",inset=0.015,cex=0.85)
	endPlot()


return(c(U50,Reg2,a,b))
}
#getGumbel50yExtreme(ym,Avail[1,])

