











#################################################################################
# more atypic functions
#################################################################################
dailyPlot=function(workdir="E:/R-Data/valid",year=2007,month=1,day=2,T=0.25,
                   Channels=list("MM3_WS80_240")
                   #Channels=list("MM3_WS80_240","MM3_WD80_240","T5_Pwsnac" ,"T5_Pwdnac","T6_Pwsnac","T6_Pwdnac")
                    ){
  setwd(paste(workdir,year,month,day,sep="/"))
  n=length(Channels)
  m=floor(n/2);
  par(mfcol = c(m,2));
  for(i in 1:n){
    par(mfcol = c(m,2),mfg = c( (floor((i-1)/2)%%3)+1  , (i-1)%%2+1))
    filename=getFileName("validRDay",year,month,day,T,Channels[[i]])
    print(filename)
    if(file.exists(filename)){
      load(filename)
 #     plot(1:10)
      l=length(XDay)
      plot(XDay[seq(1,l,)],pch=".",type = "p", col = "gray", axes = TRUE,ylab=Channels[i],xlab="t",main=Channels[i])
    }else{print("File not found")}
  }
}



# plotting overview of a gust list
plotGustsList=function(L, Gusts){
   par(mfcol = c(3,2));
   n=floor(length(L)/6)
   for(i in 1:n){
       dev.new()
       for(j in 1:6){
         par(mfcol = c(3,2));
         par(mfcol = c(3,2),mfg = c( (floor((j-1)/2)%%3)+1  , (j-1)%%2+1))
         par(new=TRUE)
         l=length(Gusts[[ L[(i-1)*6+j] ]])
         t=(1:l-l/2)
         plot(t, Gusts[[ L[(i-1)*6+j] ]],pch=".",type = "o", col = "blue", axes = TRUE,ylab="u",xlab="t",main=(L[(i-1)*6+j]))
       }
       Sys.sleep(12)
       dev.off()
   }
}





plotTurbineParameterSideBySide=function(turbineLabels,timeValues,Param1=list(),Param2=list(),title1=list(),title2=list(),Ylim1,Ylim2,Ylab1="",Ylab2="",t=list()){
    m=length(turbineLabels)
    par(mfcol = c(m,2));
    i=1;
    for(lab in turbineLabels){
      par(mfcol = c(m,2),mfg = c(i  , 1))
      plot(timeValues,Param1[[lab]],type="o",pch=".",col="red", axes = TRUE,ylim=Ylim1,ylab=Ylab1,xlab="t [s]",main=title1[[lab]])
      lines(list(t[[lab]],t[[lab]]) , as.list(Ylim1),col="mediumorchid4",lty=1)

   par(mfcol = c(m,2),mfg = c(i  , 2))
      plot(timeValues,Param2[[lab]],type="o",pch=".",col="red", axes = TRUE,ylim=Ylim2,ylab=Ylab2,xlab="t [s]",main=title2[[lab]])
      lines(list(t[[lab]],t[[lab]]) , as.list(Ylim2),col="mediumorchid4",lty=1)
    i=i+1;
    }
}


