distributionSigmaU=function(Filenames=c("MM3_WS_2006_600s.csv","MM3_WS_2007_600s.csv","MM3_WS_2008_600s.csv"),wsStart=2,wsEnd=25,wsStep=1,sigmaStart=0,sigmaEnd=4,sigmaStep=0.5,workdir="E:/ExtremeLoads",SurPlot=TRUE){
  setwd(workdir)
  A=read.csv(file=Filenames[1],sep=";")
  for(filename in Filenames[2:end(Filenames)[1]]){
    B=read.csv(file=filename,sep=";")
    A=rbind(A,B)
    rm(B)
  }

  WS=as.numeric(A[,2])
  Std=as.numeric(A[,3])

  rm(A)
  l=length(WS)

  wsBins=seq(wsStart+wsStep/2,wsEnd,wsStep)
  sigmaBins=seq(sigmaStart+sigmaStep/2,sigmaEnd,sigmaStep)

  if(0){
    MOcc=matrix(0,length(wsBins),length(sigmaBins))
    Mlnorm=matrix(NA,length(wsBins),2)
    ymax=0;
    pb<-txtProgressBar(0,length(wsBins))
    for(ws in wsBins){
      i=floor((ws-wsStart)/wsStep)+1
      for(sig in sigmaBins){
        j=floor((sig-sigmaStart)/sigmaStep)+1
        SigAux=Std[which( Std>=(sig-sigmaStep/2) & Std<(sig+sigmaStep/2) & WS>=(ws-wsStep/2) & WS<(ws+wsStep/2) )]
        MOcc[i,j]=length(SigAux)
      }
      SigAux=Std[ which( Std>=sigmaStart & Std<sigmaEnd &  WS>=(ws-wsStep/2) & WS<(ws+wsStep/2) )]
      if(length(SigAux)>5){ ln = fitdistr(SigAux,"log-normal")
        ymax=max(ymax,SigAux)
        Mlnorm[i,1]=ln[[1]][1]
        Mlnorm[i,2]=ln[[1]][2]
        print(ws)
      }
      setTxtProgressBar(pb,i)
    }
    close(pb)
    #################################################
    ## Saving
    #################################################
    setwd(workdir)
    colnames(MOcc)=sigmaBins
    rownames(MOcc)=wsBins
    save(MOcc,file="Distr Sig U MOcc.RData")
    write.table(MOcc, file ="Distr Sig U MOcc.csv", sep = ";", dec = ",", col.names =TRUE, row.names = TRUE) # save data as a csv file
    rownames(Mlnorm)=wsBins
    save(Mlnorm,file="Distr Sig U Mlnorm.RData")
    write.table(Mlnorm, file = "Distr Sig U Mlnorm.csv", sep = ";", dec = ",", col.names =TRUE, row.names = TRUE) # save data as a csv file
  }



  ################################################
  ## plotting
  ###############################################
  load(file="Distr Sig U Mlnorm.RData")
  Vpch=c(0,1,2,5,6)
  Vlty=c(rep(1,length(Vpch)),rep(2,length(Vpch)),rep(3,length(Vpch)),rep(4,length(Vpch)))
  Legends=list()
  ymax=2
  if(1){
    wsStart2=wsStart
    wsEnd2=wsEnd
    if(SurPlot){wsStep2=floor((wsEnd2-wsStart2)/4)}else{wsStep2=2*wsStep}
    if(SurPlot){sigmaStep2=sigmaStep/5}else{sigmaStep2=sigmaStep/6}
    wsBins2=seq(wsStart2+wsStep2/2,wsEnd2,wsStep2)
    n=0;
    if(SurPlot){title="PDF of sigma for different wind speeds"
                beginPlot(main=title)}

    for(ws in wsBins2){
      i=floor((ws-wsStart)/wsStep)+1
      if(!is.na(Mlnorm[i,1]) && !is.na(Mlnorm[i,2])){
        n=n+1;
        if(!SurPlot){
                title=sprintf("PDF of sigma, U=%02.1fm/s",ws)
                beginPlot(main=title)
                n=1;
        }
        SigAux=Std[ which( Std>=sigmaStart & Std<sigmaEnd &  WS>=(ws-wsStep/2) & WS<(ws+wsStep/2)  )]
        l=length(SigAux)
        s=seq(sigmaStart,sigmaEnd,0.05)
        M=data2bins(SigAux,NULL,xmin=sigmaStart,xmax=sigmaEnd,step=sigmaStep2,Integral=TRUE)
        if(n==1){
          plot(M[,1],M[,2],ylim=c(0,ymax),xlim=c(sigmaStart,sigmaEnd),main=title,xlab="sigma [m/s]",ylab="PDF []",pch=Vpch[(n-1)%%length(Vpch)+1],col="blue")
        }else{
          par(new=TRUE)
          plot(M[,1],M[,2],ylim=c(0,ymax),xlim=c(sigmaStart,sigmaEnd),xlab="",ylab="",pch=Vpch[(n-1)%%length(Vpch)+1],col="blue")
        }
        par(new=TRUE)
        plot(s, dlnorm(s,Mlnorm[i,1],Mlnorm[i,2]), lwd=1, col="black",type="o",pch="",axes=FALSE,xlab="",ylab="",xlim=c(sigmaStart,sigmaEnd),ylim=c(0,ymax),lty=Vlty[(n-1)%%(length(Vlty))+1])
        Legends[[n]]=sprintf("WS:%02.1f,m:%02.1f,sd:%1.2f,N:%04.0f",ws, Mlnorm[i,1],Mlnorm[i,2],l)
        if(!SurPlot){legend("topright",legend=Legends,pch=Vpch,lty=Vlty,bg="white"); endPlot()}
      }
    }
    if(SurPlot){
      if(length(Legends)>0){
        legend("topright",legend=Legends,pch=Vpch,lty=Vlty,bg="white")
      }
      endPlot();
    }
  }
}
#distributionSigmaU()